Index: GraphicsMagick-1.2.5/coders/png.c
===================================================================
--- GraphicsMagick-1.2.5.orig/coders/png.c	2018-01-19 20:08:30.737576639 +0100
+++ GraphicsMagick-1.2.5/coders/png.c	2018-01-19 20:29:20.474317244 +0100
@@ -7588,10 +8291,68 @@ static unsigned int WritePNGImage(const
   */
   (void) memset(mng_info,0,sizeof(MngInfo));
   mng_info->image=image;
-  have_mng_structure=True;
+  have_mng_structure=MagickTrue;
   mng_info->write_png8=LocaleCompare(image_info->magick,"PNG8") == 0;
   mng_info->write_png24=LocaleCompare(image_info->magick,"PNG24") == 0;
   mng_info->write_png32=LocaleCompare(image_info->magick,"PNG32") == 0;
+  mng_info->write_png48=LocaleCompare(image_info->magick,"PNG48") == 0;
+  mng_info->write_png64=LocaleCompare(image_info->magick,"PNG64") == 0;
+
+        if (LocaleCompare(image_info->magick,"png00") == 0)
+          {
+          const ImageAttribute
+            *attribute;
+
+          /* Retrieve png:IHDR.bit-depth-orig and png:IHDR.color-type-orig */
+          (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+             "  Format=%s",image_info->magick);
+
+          attribute=GetImageAttribute(image,"png:IHDR.bit-depth-orig");
+
+          if (attribute != (ImageAttribute *) NULL)
+            {
+              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                 "  png00 inherited bit depth=%s",attribute->value);
+
+              if (LocaleCompare(attribute->value,"1") == 0)
+                mng_info->write_png_depth = 1;
+
+              else if (LocaleCompare(attribute->value,"1") == 0)
+                mng_info->write_png_depth = 2;
+
+              else if (LocaleCompare(attribute->value,"2") == 0)
+                mng_info->write_png_depth = 4;
+
+              else if (LocaleCompare(attribute->value,"8") == 0)
+                mng_info->write_png_depth = 8;
+
+              else if (LocaleCompare(attribute->value,"16") == 0)
+                mng_info->write_png_depth = 16;
+            }
+
+          attribute=GetImageAttribute(image,"png:IHDR.color-type-orig");
+
+          if (attribute != (ImageAttribute *) NULL)
+            {
+              (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                 "  png00 inherited color type=%s",attribute->value);
+
+              if (LocaleCompare(attribute->value,"0") == 0)
+                mng_info->write_png_colortype = 1;
+
+              else if (LocaleCompare(attribute->value,"2") == 0)
+                mng_info->write_png_colortype = 3;
+
+              else if (LocaleCompare(attribute->value,"3") == 0)
+                mng_info->write_png_colortype = 4;
+
+              else if (LocaleCompare(attribute->value,"4") == 0)
+                mng_info->write_png_colortype = 5;
+
+              else if (LocaleCompare(attribute->value,"6") == 0)
+                mng_info->write_png_colortype = 7;
+            }
+        }
 
   status=WriteOnePNGImage(mng_info,image_info,image);
 
@@ -7606,7 +8367,7 @@ static unsigned int WritePNGImage(const
 #if defined(JNG_SUPPORTED)
 
 /* Write one JNG image */
-static unsigned int WriteOneJNGImage(MngInfo *mng_info,
+static MagickPassFail WriteOneJNGImage(MngInfo *mng_info,
                                      const ImageInfo *image_info,Image *image)
 {
   Image
@@ -7639,11 +8400,19 @@ static unsigned int WriteOneJNGImage(Mng
   logging=LogMagickEvent(CoderEvent,GetMagickModule(),
                          "  enter WriteOneJNGImage()");
 
+  if (image->columns > 65535 || image->rows > 65535)
+    {
+      (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                              "  JNG dimensions too large");
+      ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,
+                             image);
+    }
+
   blob=(char *) NULL;
   jpeg_image=(Image *) NULL;
   jpeg_image_info=(ImageInfo *) NULL;
 
-  status=True;
+  status=MagickTrue;
   transparent=image_info->type==GrayscaleMatteType ||
     image_info->type==TrueColorMatteType;
   jng_color_type=10;
@@ -7654,7 +8423,7 @@ static unsigned int WriteOneJNGImage(Mng
   if (image->matte)
     {
       /* if any pixels are transparent */
-      transparent=True;
+      transparent=MagickTrue;
       if (image_info->compression==JPEGCompression)
         jng_alpha_compression_method=8;
     }
@@ -7673,19 +8442,29 @@ static unsigned int WriteOneJNGImage(Mng
       if (logging)
         (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                               "  Creating jpeg_image.");
-      jpeg_image=CloneImage(image,0,0,True,&image->exception);
+      jpeg_image=CloneImage(image,0,0,MagickTrue,&image->exception);
       if (jpeg_image == (Image *) NULL)
-      {
-        if (jpeg_image_info != (ImageInfo *)NULL)
-          DestroyImageInfo(jpeg_image_info);
-        ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,
-                             image);
-      }
+        {
+          if (jpeg_image_info != (ImageInfo *)NULL)
+            {
+              DestroyImageInfo(jpeg_image_info);
+            }
+          ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,
+                               image);
+        }
       DestroyBlob(jpeg_image);
       jpeg_image->blob=CloneBlobInfo((BlobInfo *) NULL);
       status=ChannelImage(jpeg_image,OpacityChannel);
-      status=NegateImage(jpeg_image,False);
-      jpeg_image->matte=False;
+      if (status != MagickFalse)
+        status=NegateImage(jpeg_image,MagickFalse);
+      if (status == MagickFalse)
+        {
+          DestroyImage(jpeg_image);
+          DestroyImageInfo(jpeg_image_info);
+          ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,
+                               image);
+        }
+      jpeg_image->matte=MagickFalse;
       if (jng_quality >= 1000)
         jpeg_image_info->quality=jng_quality/1000;
       else
@@ -7712,25 +8491,28 @@ static unsigned int WriteOneJNGImage(Mng
             *attribute;
 
           /* Encode opacity as a grayscale PNG blob */
-          status=OpenBlob(jpeg_image_info,jpeg_image,WriteBinaryBlobMode,
-                          &image->exception);
           if (logging)
             (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                                   "  Creating PNG blob.");
-          length=0;
+          status=OpenBlob(jpeg_image_info,jpeg_image,WriteBinaryBlobMode,
+                          &image->exception);
+          if (status != MagickFalse)
+            {
+              length=0;
 
-          (void) strlcpy(jpeg_image_info->magick,"PNG",MaxTextExtent);
-          (void) strlcpy(jpeg_image->magick,"PNG",MaxTextExtent);
-          jpeg_image_info->interlace=NoInterlace;
-
-          blob=(char *) ImageToBlob(jpeg_image_info,jpeg_image,&length,
-                                    &image->exception);
-
-          /* Retrieve sample depth used */
-          attribute=GetImageAttribute(jpeg_image,"[png_bit_depth]");
-          if ((attribute != (const ImageAttribute *) NULL) &&
-              (attribute->value != (char *) NULL))
-            jng_alpha_sample_depth= (unsigned int) attribute->value[0];
+              (void) strlcpy(jpeg_image_info->magick,"PNG",MaxTextExtent);
+              (void) strlcpy(jpeg_image->magick,"PNG",MaxTextExtent);
+              jpeg_image_info->interlace=NoInterlace;
+
+              blob=(char *) ImageToBlob(jpeg_image_info,jpeg_image,&length,
+                                        &image->exception);
+
+              /* Retrieve sample depth used */
+              attribute=GetImageAttribute(jpeg_image,"[png:bit-depth-written]");
+              if ((attribute != (const ImageAttribute *) NULL) &&
+                  (attribute->value != (char *) NULL))
+                jng_alpha_sample_depth= (unsigned int) attribute->value[0];
+            }
         }
       else
         {
@@ -7738,26 +8520,32 @@ static unsigned int WriteOneJNGImage(Mng
 
           status=OpenBlob(jpeg_image_info,jpeg_image,WriteBinaryBlobMode,
                           &image->exception);
+          if (status != MagickFalse)
+            {
+              (void) strlcpy(jpeg_image_info->magick,"JPEG",MaxTextExtent);
+              (void) strlcpy(jpeg_image->magick,"JPEG",MaxTextExtent);
+              jpeg_image_info->interlace=NoInterlace;
+              if (logging)
+                (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                                      "  Creating blob.");
+              blob=(char *) ImageToBlob(jpeg_image_info,jpeg_image,&length,
+                                        &image->exception);
+              jng_alpha_sample_depth=8;
+              if (logging)
+                (void) LogMagickEvent(CoderEvent,GetMagickModule(),
+                                      "  Successfully read jpeg_image into a"
+                                      " blob, length=%lu.",
+                                      (unsigned long) length);
 
-          (void) strlcpy(jpeg_image_info->magick,"JPEG",MaxTextExtent);
-          (void) strlcpy(jpeg_image->magick,"JPEG",MaxTextExtent);
-          jpeg_image_info->interlace=NoInterlace;
-          if (logging)
-            (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                  "  Creating blob.");
-          blob=(char *) ImageToBlob(jpeg_image_info,jpeg_image,&length,
-                                    &image->exception);
-          jng_alpha_sample_depth=8;
-          if (logging)
-            (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                  "  Successfully read jpeg_image into a blob, length=%lu.",
-                                  (unsigned long) length);
-
+            }
         }
       /* Destroy JPEG image and image_info */
       (void) LiberateUniqueFileResource(jpeg_image_info->filename);
       DestroyImage(jpeg_image);
       DestroyImageInfo(jpeg_image_info);
+      if (status == MagickFalse)
+        ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,
+                             image);
     }
 
   /* Write JHDR chunk */
@@ -7769,7 +8557,7 @@ static unsigned int WriteOneJNGImage(Mng
   chunk[12]=jng_color_type;
   chunk[13]=8;  /* sample depth */
   chunk[14]=8; /*jng_image_compression_method */
-  chunk[15]=image_info->interlace == NoInterlace ? 0 : 8;
+  chunk[15]=(image_info->interlace == LineInterlace) ? 8 : 0;
   chunk[16]=jng_alpha_sample_depth;
   chunk[17]=jng_alpha_compression_method;
   chunk[18]=0; /*jng_alpha_filter_method */
@@ -7951,7 +8739,7 @@ static unsigned int WriteOneJNGImage(Mng
     {
       if (jng_alpha_compression_method==0)
         {
-          long
+          unsigned long
             len;
 
           register long
@@ -7968,9 +8756,9 @@ static unsigned int WriteOneJNGImage(Mng
           p=(unsigned char *) (blob+8);
           for (i=8; i<(long) length; i+=len+12)
             {
-              len=(*p<<24)|((*(p+1))<<16)|((*(p+2))<<8)|(*(p+3));
+              len=mng_get_long(p);
               p+=4;
-              if (*(p)==73 && *(p+1)==68 && *(p+2)==65 && *(p+3)==84) /* IDAT */
+              if (*(p)==73 && *(p+1)==68 && *(p+2)==65 && *(p+3)==84)
                 {
                   /* Found an IDAT chunk. */
                   (void) WriteBlobMSBULong(image,(unsigned long) len);
@@ -7983,7 +8771,8 @@ static unsigned int WriteOneJNGImage(Mng
                 {
                   if (logging)
                     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                                          "    Skipping %c%c%c%c chunk, length=%lu.",
+                                          "    Skipping %c%c%c%c chunk,"
+                                          " length=%lu.",
                                           *(p),*(p+1),*(p+2),*(p+3),len);
                 }
               p+=(8+len);
@@ -7998,12 +8787,12 @@ static unsigned int WriteOneJNGImage(Mng
                                   (unsigned long) length);
           (void) WriteBlobMSBULong(image,(unsigned long) length);
           PNGType(chunk,mng_JDAA);
-          LogPNGChunk(logging,mng_JDAA,length);
+          LogPNGChunk(logging,mng_JDAA,(unsigned long) length);
           /* Write JDAT chunk(s) data */
           (void) WriteBlob(image,4,(char *) chunk);
           (void) WriteBlob(image,length,(char *) blob);
           (void) WriteBlobMSBULong(image,crc32(crc32(0,chunk,4),
-                                               (unsigned char *) blob,length));
+                                               (unsigned char *) blob,(uInt) length));
         }
       MagickFreeMemory(blob);
     }
@@ -8021,14 +8810,13 @@ static unsigned int WriteOneJNGImage(Mng
     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                           "  Creating jpeg_image.");
 
-  jpeg_image=CloneImage(image,0,0,True,&image->exception);
+  jpeg_image=CloneImage(image,0,0,MagickTrue,&image->exception);
   if (jpeg_image == (Image *) NULL)
-  {
-    if (jpeg_image_info != (ImageInfo *)NULL)
+    {
       DestroyImageInfo(jpeg_image_info);
-    ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,
-                         image);
-  }
+      ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,
+                           image);
+    }
   DestroyBlob(jpeg_image);
   jpeg_image->blob=CloneBlobInfo((BlobInfo *) NULL);
   (void) AcquireUniqueFilename(jpeg_image->filename);
@@ -8036,10 +8824,20 @@ static unsigned int WriteOneJNGImage(Mng
 
   status=OpenBlob(jpeg_image_info,jpeg_image,WriteBinaryBlobMode,
                   &image->exception);
+  if (status == MagickFalse)
+    {
+      if (jpeg_image != (Image *)NULL)
+        DestroyImage(jpeg_image);
+      if (jpeg_image_info != (ImageInfo *)NULL)
+        DestroyImageInfo(jpeg_image_info);
+      ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,
+                           image);
+    }
 
   if (logging)
     (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                          "  Created jpeg_image, %lu x %lu.",jpeg_image->columns,
+                          "  Created jpeg_image, %lu x %lu.",
+                          jpeg_image->columns,
                           jpeg_image->rows);
 
   if (jng_color_type == 8 || jng_color_type == 12)
@@ -8055,7 +8853,8 @@ static unsigned int WriteOneJNGImage(Mng
   if (logging)
     {
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                            "  Successfully read jpeg_image into a blob, length=%lu.",
+                            "  Successfully read jpeg_image into a blob,"
+                            " length=%lu.",
                             (unsigned long) length);
 
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
@@ -8065,11 +8864,11 @@ static unsigned int WriteOneJNGImage(Mng
   /* Write JDAT chunk(s) */
   (void) WriteBlobMSBULong(image,(unsigned long) length);
   PNGType(chunk,mng_JDAT);
-  LogPNGChunk(logging,mng_JDAT,length);
+  LogPNGChunk(logging,mng_JDAT,(unsigned long) length);
   (void) WriteBlob(image,4,(char *) chunk);
   (void) WriteBlob(image,length,(char *) blob);
   (void) WriteBlobMSBULong(image,crc32(crc32(0,chunk,4),(unsigned char *)
-                                       blob,length));
+                                       blob,(uInt)length));
 
   (void) LiberateUniqueFileResource(jpeg_image_info->filename);
   DestroyImage(jpeg_image);
@@ -8090,7 +8889,34 @@ static unsigned int WriteOneJNGImage(Mng
 }
 
 
-static unsigned int WriteJNGImage(const ImageInfo *image_info,Image *image)
+/*
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%                                                                             %
+%                                                                             %
+%                                                                             %
+%   W r i t e J N G I m a g e                                                 %
+%                                                                             %
+%                                                                             %
+%                                                                             %
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+%
+%  WriteJNGImage() writes a JPEG Network Graphics (JNG) image file.
+%
+%  JNG support written by Glenn Randers-Pehrson, glennrp@image...
+%
+%  The format of the WriteJNGImage method is:
+%
+%      MagickPassFail WriteJNGImage(const ImageInfo *image_info,Image *image)
+%
+%  A description of each parameter follows:
+%
+%    o image_info: the image info.
+%
+%    o image:  The image.
+%
+%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+*/
+static MagickPassFail WriteJNGImage(const ImageInfo *image_info,Image *image)
 {
   MngInfo
     *mng_info;
@@ -8111,13 +8937,13 @@ static unsigned int WriteJNGImage(const
   assert(image->signature == MagickSignature);
   logging=LogMagickEvent(CoderEvent,GetMagickModule(),"enter WriteJNGImage()");
   status=OpenBlob(image_info,image,WriteBinaryBlobMode,&image->exception);
-  if (status == False)
+  if (status == MagickFalse)
     ThrowWriterException(FileOpenError,UnableToOpenFile,image);
 
   /*
     Allocate a MngInfo structure.
   */
-  have_mng_structure=False;
+  have_mng_structure=MagickFalse;
   mng_info=MagickAllocateMemory(MngInfo *,sizeof(MngInfo));
   if (mng_info == (MngInfo *) NULL)
     ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,image);
@@ -8126,7 +8952,7 @@ static unsigned int WriteJNGImage(const
   */
   (void) memset(mng_info,0,sizeof(MngInfo));
   mng_info->image=image;
-  have_mng_structure=True;
+  have_mng_structure=MagickTrue;
 
   (void) WriteBlob(image,8,"\213JNG\r\n\032\n");
 
@@ -8165,7 +8991,7 @@ static unsigned int WriteMNGImage(const
     all_images_are_gray,
     logging,
     need_defi,
-    optimize,
+    build_palette,
     use_global_plte;
 
   register long
@@ -8176,22 +9002,21 @@ static unsigned int WriteMNGImage(const
     chunk_length=0;
 #endif
 
-  unsigned char
-    chunk[800];
-
   unsigned int
     status;
 
   volatile unsigned int
-    scene,
     write_jng,
     write_mng;
 
+  volatile unsigned long
+    scene;
+
   unsigned long
     final_delay=0,
     initial_delay;
 
-#if (PNG_LIBPNG_VER < 10007)
+#if (PNG_LIBPNG_VER < 10200)
   if (image_info->verbose)
     printf("Your PNG library (libpng-%s) is rather old.\n",
            PNG_LIBPNG_VER_STRING);
@@ -8206,13 +9031,13 @@ static unsigned int WriteMNGImage(const
   assert(image->signature == MagickSignature);
   logging=LogMagickEvent(CoderEvent,GetMagickModule(),"enter WriteMNGImage()");
   status=OpenBlob(image_info,image,WriteBinaryBlobMode,&image->exception);
-  if (status == False)
+  if (status == MagickFalse)
     ThrowWriterException(FileOpenError,UnableToOpenFile,image);
 
   /*
     Allocate a MngInfo structure.
   */
-  have_mng_structure=False;
+  have_mng_structure=MagickFalse;
   mng_info=MagickAllocateMemory(MngInfo *,sizeof(MngInfo));
   if (mng_info == (MngInfo *) NULL)
     ThrowWriterException(ResourceLimitError,MemoryAllocationFailed,image);
@@ -8221,16 +9046,18 @@ static unsigned int WriteMNGImage(const
   */
   (void) memset(mng_info,0,sizeof(MngInfo));
   mng_info->image=image;
-  have_mng_structure=True;
+  have_mng_structure=MagickTrue;
 
   write_mng=LocaleCompare(image_info->magick,"MNG") == 0;
   mng_info->write_png8=LocaleCompare(image_info->magick,"PNG8") == 0;
   mng_info->write_png24=LocaleCompare(image_info->magick,"PNG24") == 0;
   mng_info->write_png32=LocaleCompare(image_info->magick,"PNG32") == 0;
+  mng_info->write_png48=LocaleCompare(image_info->magick,"PNG48") == 0;
+  mng_info->write_png64=LocaleCompare(image_info->magick,"PNG64") == 0;
 
-  write_jng=False;
+  write_jng=MagickFalse;
   if (image_info->compression==JPEGCompression)
-    write_jng=True;
+    write_jng=MagickTrue;
   else
     {
       Image
@@ -8239,18 +9066,22 @@ static unsigned int WriteMNGImage(const
       for (p=image; p != (Image *) NULL; p=p->next)
         {
           if (p->compression==JPEGCompression)
-            write_jng=True;
+            write_jng=MagickTrue;
         }
     }
 
   mng_info->adjoin=image_info->adjoin && (image->next != (Image *) NULL) &&
     write_mng;
 
-  if (mng_info->write_png8 || mng_info->write_png24 || mng_info->write_png32)
-    optimize=False;
+#ifdef GMPNG_BUILD_PALETTE
+  if (mng_info->write_png8)
+    build_palette=MagickTrue;
+  else if (mng_info->write_png24 || mng_info->write_png32 ||
+      mng_info->write_png48 || mng_info->write_png64)
+    build_palette=MagickFalse;
   else
-    optimize=(image_info->type == OptimizeType || image_info->type ==
-              UndefinedType);
+    build_palette=(image_info->type == UndefinedType);
+#endif
 
   if (logging)
     {
@@ -8258,17 +9089,9 @@ static unsigned int WriteMNGImage(const
       Image
         *p;
 
-      long
-        scene;
-
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                             "  Checking input image(s)");
-      if (optimize)
-        (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                              "    Optimize: TRUE");
-      else
-        (void) LogMagickEvent(CoderEvent,GetMagickModule(),
-                              "    Optimize: FALSE");
+
       (void) LogMagickEvent(CoderEvent,GetMagickModule(),
                             "    Image_info depth: %ld",
                             image_info->depth);
@@ -8322,8 +9145,8 @@ static unsigned int WriteMNGImage(const
       }
   }
 
-#ifdef PNG_BUILD_PALETTE
-  if (optimize)
+#ifdef GMPNG_BUILD_PALETTE
+  if (build_palette)
     {
       /*
         Sometimes we get DirectClass images that have 256 colors or fewer.
@@ -8352,13 +9175,13 @@ static unsigned int WriteMNGImage(const
     }
 #endif
 
-  use_global_plte=False;
-  all_images_are_gray=False;
+  use_global_plte=MagickFalse;
+  all_images_are_gray=MagickFalse;
 #ifdef PNG_WRITE_EMPTY_PLTE_SUPPORTED
-  need_local_plte=True;
+  need_local_plte=MagickTrue;
 #endif
-  need_defi=False;
-  need_matte=False;
+  need_defi=MagickFalse;
+  need_matte=MagickFalse;
   mng_info->framing_mode=1;
   mng_info->old_framing_mode=1;
 
@@ -8370,10 +9193,14 @@ static unsigned int WriteMNGImage(const
         */
         SetGeometry(image,&mng_info->page);
         (void) ParseMetaGeometry(image_info->page,&mng_info->page.x,
-                                 &mng_info->page.y,&mng_info->page.width,&mng_info->page.height);
+                                 &mng_info->page.y,&mng_info->page.width,
+                                 &mng_info->page.height);
       }
   if (write_mng)
     {
+      unsigned char
+        chunk[800];
+
       unsigned int
         need_geom;
 
@@ -8383,46 +9210,49 @@ static unsigned int WriteMNGImage(const
         blue;
 
       mng_info->page=image->page;
-      need_geom=True;
+      need_geom=MagickTrue;
       if (mng_info->page.width || mng_info->page.height)
-        need_geom=False;
+        need_geom=MagickFalse;
       /*
         Check all the scenes.
       */
       initial_delay=(long) image->delay;
-      need_iterations=False;
+      need_iterations=MagickFalse;
       mng_info->equal_chrms=image->chromaticity.red_primary.x != 0.0;
-      mng_info->equal_physs=True,
-        mng_info->equal_gammas=True;
-      mng_info->equal_srgbs=True;
-      mng_info->equal_backgrounds=True;
+      mng_info->equal_physs=MagickTrue,
+        mng_info->equal_gammas=MagickTrue;
+      mng_info->equal_srgbs=MagickTrue;
+      mng_info->equal_backgrounds=MagickTrue;
       image_count=0;
 #if defined(PNG_WRITE_EMPTY_PLTE_SUPPORTED) ||  \
   defined(PNG_MNG_FEATURES_SUPPORTED)
-      all_images_are_gray=True;
-      mng_info->equal_palettes=False;
-      need_local_plte=False;
+      all_images_are_gray=MagickTrue;
+      mng_info->equal_palettes=MagickFalse;
+      need_local_plte=MagickFalse;
 #endif
       for (next_image=image; next_image != (Image *) NULL; )
         {
           if (need_geom)
             {
-              if ((next_image->columns+next_image->page.x) > mng_info->page.width)
+              if ((next_image->columns+next_image->page.x) >
+                   mng_info->page.width)
                 mng_info->page.width=next_image->columns+next_image->page.x;
-              if ((next_image->rows+next_image->page.y) > mng_info->page.height)
+              if ((next_image->rows+next_image->page.y) >
+                   mng_info->page.height)
                 mng_info->page.height=next_image->rows+next_image->page.y;
             }
           if (next_image->page.x || next_image->page.y)
-            need_defi=True;
+            need_defi=MagickTrue;
           if (next_image->matte)
-            need_matte=True;
+            need_matte=MagickTrue;
           if ((int) next_image->dispose >= BackgroundDispose)
-            if (next_image->matte || next_image->page.x || next_image->page.y ||
+            if (next_image->matte || next_image->page.x ||
+                next_image->page.y ||
                 ((next_image->columns < mng_info->page.width) &&
                  (next_image->rows < mng_info->page.height)))
-              mng_info->need_fram=True;
+              mng_info->need_fram=MagickTrue;
           if (next_image->iterations)
-            need_iterations=True;
+            need_iterations=MagickTrue;
           final_delay=next_image->delay;
           if (final_delay != initial_delay || final_delay > 100)
             mng_info->need_fram=1;
@@ -8432,11 +9262,11 @@ static unsigned int WriteMNGImage(const
             check for global palette possibility.
           */
           if (image->matte)
-            need_local_plte=True;
+            need_local_plte=MagickTrue;
           if (!need_local_plte)
             {
               if (!IsGrayImage(image,&image->exception))
-                all_images_are_gray=False;
+                all_images_are_gray=MagickFalse;
               mng_info->equal_palettes=PalettesAreEqual(image,next_image);
               if (!use_global_plte)
                 use_global_plte=mng_info->equal_palettes;
@@ -8451,16 +9281,17 @@ static unsigned int WriteMNGImage(const
                   next_image->next->background_color.green ||
                   next_image->background_color.blue !=
                   next_image->next->background_color.blue)
-                mng_info->equal_backgrounds=False;
+                mng_info->equal_backgrounds=MagickFalse;
               if (next_image->gamma != next_image->next->gamma)
-                mng_info->equal_gammas=False;
+                mng_info->equal_gammas=MagickFalse;
               if (next_image->rendering_intent !=
                   next_image->next->rendering_intent)
-                mng_info->equal_srgbs=False;
+                mng_info->equal_srgbs=MagickFalse;
               if ((next_image->units != next_image->next->units) ||
-                  (next_image->x_resolution != next_image->next->x_resolution) ||
+                  (next_image->x_resolution !=
+                  next_image->next->x_resolution) ||
                   (next_image->y_resolution != next_image->next->y_resolution))
-                mng_info->equal_physs=False;
+                mng_info->equal_physs=MagickFalse;
               if (mng_info->equal_chrms)
                 {
                   if (next_image->chromaticity.red_primary.x !=
@@ -8479,7 +9310,7 @@ static unsigned int WriteMNGImage(const
                       next_image->next->chromaticity.white_point.x ||
                       next_image->chromaticity.white_point.y !=
                       next_image->next->chromaticity.white_point.y)
-                    mng_info->equal_chrms=False;
+                    mng_info->equal_chrms=MagickFalse;
                 }
             }
           image_count++;
@@ -8487,16 +9318,16 @@ static unsigned int WriteMNGImage(const
         }
       if (image_count < 2)
         {
-          mng_info->equal_backgrounds=False;
-          mng_info->equal_chrms=False;
-          mng_info->equal_gammas=False;
-          mng_info->equal_srgbs=False;
-          mng_info->equal_physs=False;
-          use_global_plte=False;
+          mng_info->equal_backgrounds=MagickFalse;
+          mng_info->equal_chrms=MagickFalse;
+          mng_info->equal_gammas=MagickFalse;
+          mng_info->equal_srgbs=MagickFalse;
+          mng_info->equal_physs=MagickFalse;
+          use_global_plte=MagickFalse;
 #ifdef PNG_WRITE_EMPTY_PLTE_SUPPORTED
-          need_local_plte=True;
+          need_local_plte=MagickTrue;
 #endif
-          need_iterations=False;
+          need_iterations=MagickFalse;
         }
       if (!mng_info->need_fram)
         {
@@ -8513,7 +9344,8 @@ static unsigned int WriteMNGImage(const
                   */
                   final_delay=10;
                   (void) ThrowException2(&image->exception,CoderError,
-                                         "input has zero delay between all frames; assuming 10 cs",
+                                         "input has zero delay between"
+                                         " all frames; assuming 10 cs",
                                          (char *) NULL);
                 }
               else
@@ -8526,11 +9358,14 @@ static unsigned int WriteMNGImage(const
           if (final_delay > 75)
             mng_info->ticks_per_second=1;
           if (final_delay > 125)
-            mng_info->need_fram=True;
+            mng_info->need_fram=MagickTrue;
           if (need_defi && final_delay > 2 && (final_delay != 4) &&
-              (final_delay != 5) && (final_delay != 10) && (final_delay != 20) &&
-              (final_delay != 25) && (final_delay != 50) && (final_delay != 100))
-            mng_info->need_fram=True;  /* make it exact; cannot be VLC anyway */
+              (final_delay != 5) && (final_delay != 10) &&
+              (final_delay != 20) &&
+              (final_delay != 25) && (final_delay != 50) &&
+              (final_delay != 100))
+            mng_info->need_fram=MagickTrue;  /* make it exact;
+                                          cannot be VLC anyway */
         }
       if (mng_info->need_fram)
         mng_info->ticks_per_second=100;
@@ -8564,9 +9399,11 @@ static unsigned int WriteMNGImage(const
           else
             {
               if (need_defi || mng_info->need_fram || use_global_plte)
-                PNGLong(chunk+28,19L);  /* simplicity=LC+JNG, no transparency */
+                PNGLong(chunk+28,19L);  /* simplicity=LC+JNG,
+                                           no transparency */
               else
-                PNGLong(chunk+28,17L);  /* simplicity=VLC+JNG, no transparency */
+                PNGLong(chunk+28,17L);  /* simplicity=VLC+JNG,
+                                           no transparency */
             }
         }
       else
@@ -8598,11 +9435,11 @@ static unsigned int WriteMNGImage(const
           */
           PNGType(chunk,mng_nEED);
           chunk_length = (strlcpy((char *) chunk+4, "CACHEOFF",20));
-          (void) WriteBlobMSBULong(image,chunk_length);
-          LogPNGChunk(logging,mng_nEED,chunk_length);
+          (void) WriteBlobMSBULong(image,(const unsigned long) chunk_length);
+          LogPNGChunk(logging,mng_nEED,(unsigned long) chunk_length);
           chunk_length += 4;
           (void) WriteBlob(image,chunk_length,(char *) chunk);
-          (void) WriteBlobMSBULong(image,crc32(0,chunk,chunk_length));
+          (void) WriteBlobMSBULong(image,crc32(0,chunk,(uInt) chunk_length));
         }
 #endif
       if ((image->previous == (Image *) NULL) &&
